import 'package:oauth2/oauth2.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:suga_core/src/http/oauth2/credentials_storages/oauth2_credentials_storage.dart';

class Oauth2CredentialsSharedPreferencesStorage extends Oauth2CredentialsStorage {
  final SharedPreferences _prefs;
  final String _key;

  @Deprecated('Use Oauth2CredentialsSecureStorage for better security')
  Oauth2CredentialsSharedPreferencesStorage(
    this._prefs,
    this._key,
  );

  @override
  Future<Credentials?> get() {
    final json = _prefs.getString(_key);
    final value = json != null ? Credentials.fromJson(json) : null;
    return Future.value(value);
  }

  @override
  Future<bool> set(Credentials credentials) {
    return _prefs.setString(_key, credentials.toJson());
  }

  @override
  Future<bool> has() {
    return Future.value(_prefs.containsKey(_key));
  }

  @override
  Future<bool> remove() {
    return _prefs.remove(_key);
  }
}
